﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;
using Syncfusion.SfDataGrid.XForms;
using Syncfusion.SfDataGrid.XForms.DataPager;
using System.Globalization;

namespace DataGridDemo
{
    public partial class MainPage : ContentPage
    {
        SfDataGrid sfGrid;
        SfDataPager sfDataPager;
        public MainPage()
        {
            InitializeComponent();
            sfGrid = new SfDataGrid();
            sfDataPager = new SfDataPager();
            sfGrid.ColumnSizer = ColumnSizer.Star;
            sfDataPager.UseOnDemandPaging = true;
            sfDataPager.PageSize = 5;
            sfDataPager.Source = viewModel.OrdersInfo;
            sfGrid.ItemsSource = sfDataPager.PagedSource;
            this.sfDataPager.OnDemandLoading += DataPager_OnDemandLoading;
            Grid myGrid = new Grid();
            myGrid.HorizontalOptions = LayoutOptions.FillAndExpand;

            myGrid.RowDefinitions = new RowDefinitionCollection
            {
              new RowDefinition { Height = 50 },
              new RowDefinition {},
            };
            
            myGrid.Children.Add(sfDataPager, 0, 0);
            myGrid.Children.Add(sfGrid, 0, 1);
            this.Content = myGrid;
        }
        private void DataPager_OnDemandLoading(object sender, OnDemandLoadingEventArgs args)
        {
            sfDataPager.LoadDynamicItems(args.StartIndex, viewModel.OrdersInfo.Skip(args.StartIndex).Take(args.PageSize));
            sfDataPager.PagedSource.Refresh();
        }
    }
}
